
// w2k_pdbx.h
// 07-07-2001 Sven B. Schreiber
// sbs@orgon.com

#define UNICODE // ANSI mode not supported!

// =================================================================
// PROGRAM IDENTIFICATION
// =================================================================

#define MAIN_BUILD              1
#define MAIN_VERSION_HIGH       1
#define MAIN_VERSION_LOW        0

// -----------------------------------------------------------------

#define MAIN_DAY                07
#define MAIN_MONTH              07
#define MAIN_YEAR               2001

// -----------------------------------------------------------------

#define MAIN_MODULE             w2k_pdbx
#define MAIN_NAME               SBS Program Database Exploder
#define MAIN_COMPANY            Sven B. Schreiber
#define MAIN_AUTHOR             Sven B. Schreiber
#define MAIN_EMAIL              sbs@orgon.com
#define MAIN_PREFIX             SBS
#define MAIN_EXE

// =================================================================
// HEADER FILES
// =================================================================

#include <w32start.h>

////////////////////////////////////////////////////////////////////
#ifndef _RC_PASS_
////////////////////////////////////////////////////////////////////

// =================================================================
// MACROS
// =================================================================

#define COUNT(_n,_1,_x) (_n), ((_n) == 1 ? (_1) : (_x))

// =================================================================
// DISPLAY OPTIONS
// =================================================================

#define DISPLAY_OPTION_DEFAULT      0x00000000
#define DISPLAY_OPTION_STREAM       PDB_STREAM_MASK
#define DISPLAY_OPTION_FLAGS        (~DISPLAY_OPTION_STREAM)
#define DISPLAY_OPTION_FIRST        (DISPLAY_OPTION_STREAM + 1)

#define DISPLAY_OPTION_HEADER       (DISPLAY_OPTION_FIRST     )
#define DISPLAY_OPTION_ALLOC        (DISPLAY_OPTION_FIRST << 1)
#define DISPLAY_OPTION_ROOT         (DISPLAY_OPTION_FIRST << 2)
#define DISPLAY_OPTION_DATA         (DISPLAY_OPTION_FIRST << 3)

// =================================================================
// PDB CONSTANTS
// =================================================================

#define PDB_SIGNATURE_200 \
        "Microsoft C/C++ program database 2.00\r\n\x1AJG\0"

#define PDB_SIGNATURE_      44 // size of signature (bytes)
#define PDB_STREAM_FREE     -1
#define PDB_STREAM_MASK     0x0000FFFF
#define PDB_STREAM_MAX      (PDB_STREAM_MASK+1)

// =================================================================
// PDB STRUCTURES
// =================================================================

typedef struct _PDB_STREAM
    {
    DWORD dStreamSize;   // in bytes, -1 = free stream
    PWORD pwStreamPages; // array of page numbers
    }
    PDB_STREAM, *PPDB_STREAM, **PPPDB_STREAM;

#define PDB_STREAM_ sizeof (PDB_STREAM)

// -----------------------------------------------------------------

typedef struct _PDB_HEADER
    {
    BYTE       abSignature [PDB_SIGNATURE_]; // PDB_SIGNATURE_200
    DWORD      dPageSize;      // 0x0400, 0x0800, 0x1000
    WORD       wStartPage;     // 0x0009, 0x0005, 0x0002
    WORD       wFilePages;     // file size / dPageSize
    PDB_STREAM RootStream;     // stream directory
    WORD       awRootPages []; // pages containing PDB_ROOT
    }
    PDB_HEADER, *PPDB_HEADER, **PPPDB_HEADER;

#define PDB_HEADER_ sizeof (PDB_HEADER)
#define PDB_HEADER__(_n) (PDB_HEADER_ + ((_n) * sizeof (WORD)))

// -----------------------------------------------------------------

typedef struct _PDB_ROOT
    {
    WORD       wCount;      // < PDB_STREAM_MAX
    WORD       wReserved;   // 0
    PDB_STREAM aStreams []; // stream #0 reserved for stream table
    }
    PDB_ROOT, *PPDB_ROOT, **PPPDB_ROOT;

#define PDB_ROOT_ sizeof (PDB_ROOT)
#define PDB_ROOT__(_n) (PDB_ROOT_ + ((_n) * PDB_STREAM_))

////////////////////////////////////////////////////////////////////
#endif // #ifndef _RC_PASS_
////////////////////////////////////////////////////////////////////

// =================================================================
// END OF FILE
// =================================================================
